// Ws2_32.cpp : DLL AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "Ws2_32.h"

#include <string>

const int SOCKET_ERROR  = -1;

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

HMODULE g_module;

typedef INT (APIENTRY * WSAStartupEntry)(
    IN WORD wVersionRequested,
    OUT LPVOID lpWSADataCC
    );
typedef INT (APIENTRY * WSACleanupEntry)(
    );

WS2_32_API WSAStartup(IN WORD wVersionRequested, OUT LPVOID lpWSAData )
{
    MessageBoxW( NULL, L"WSAStartup (Hooked)", L"Ws2_32.dll (Hooked)",  MB_OK );
    wchar_t sysPath[MAX_PATH];
    const int len = GetSystemDirectoryW( sysPath, sizeof(sysPath)/sizeof(sysPath[0]) );
    if( len == 0 )
    {
        return SOCKET_ERROR;
    }

    std::wstring path = std::wstring(sysPath) + L"\\ws2_32.dll";    
    g_module = LoadLibrary( path.c_str() );

    if( g_module != NULL )
    {
	    WSAStartupEntry func = (WSAStartupEntry) GetProcAddress( g_module, "WSAStartup" );
	    return func( wVersionRequested, lpWSAData );
    }
    else
    {
        return SOCKET_ERROR;
    }
}

WS2_32_API WSACleanup()
{
    if( g_module == NULL )
    {
        return SOCKET_ERROR;
    }

	WSACleanupEntry func = (WSACleanupEntry) GetProcAddress( g_module, "WSACleanup" );
	int ret = func();
	FreeLibrary( g_module );
	return ret;

}